# You may need to run "thisroot.sh" first

src=main.cc
exe=main.exe
echo "---------------------------------------"
echo "Compiling $src with ROOT"
echo "---------------------------------------"

# g++ $src -o $exe -O2 -ansi -W -fpic -g -Wall -Wno-deprecated-copy `root-config --cflags --glibs`
g++ $src -o $exe -O2 -pedantic -W -g -Wall `root-config --cflags --glibs`

if [ $? -eq 1 ]; then
  echo
  echo "COMPILE FAILED!"
  echo
else
  echo
  echo " -> $exe"
  echo
  echo "---------------------------------------"
  echo "Executing $exe"
  echo "---------------------------------------"

  #echo "$exe Run3 Zee false"
  ./$exe Run3 Zee false >outputRun3Zee_unweighted.log 2>&1 &

  #echo "$exe Run3 Zmm false"
  ./$exe Run3 Zmm false >outputRun3Zmm_unweighted.log 2>&1 &

  #echo "$exe Run3 Zee true"
  ./$exe Run3 Zee true  >outputRun3Zee_reweighted.log 2>&1 &

  #echo "$exe Run3 Zmm true"
  ./$exe Run3 Zmm true  >outputRun3Zmm_reweighted.log 2>&1 &


  #echo "$exe Run2 Zee false"
  #./$exe Run2 Zee false >outputRun2Zee_unweighted.log 2>&1 &

  #echo "$exe Run2 Zmm false"
  #./$exe Run2 Zmm false >outputRun2Zmm_unweighted.log 2>&1 &

  #echo "$exe Run2 Zee true"
  #./$exe Run2 Zee true  >outputRun2Zee_reweighted.log 2>&1 &

  #echo "$exe Run2 Zmm true"
  #./$exe Run2 Zmm true  >outputRun2Zmm_reweighted.log 2>&1 &

fi
