//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Thu Mar  2 14:08:50 2023 by ROOT version 6.26/06
// from TTree TRT/TRT
// found on file: R22_Run2_MC_ZEE_xTRTNTupleTagAndProbe_18300.root
// Andrew: combined normal and tnp ntuples (to add missing GSF entries)
//////////////////////////////////////////////////////////

#ifndef TRT_h
#define TRT_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>

// Header file for the classes stored in the TTree if any.
#include "TVector3.h"
#include "TLorentzVector.h"
#include "vector"

class TRT {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

// Fixed size dimensions of array or collections stored in the TTree if any.

   // Declaration of leaf types

   // Event-level
   UInt_t          runNumber;
   ULong64_t       eventNumber;
   Float_t         averageInteractionsPerCrossing;
   Float_t         TRTOccupancyGlobal;
   Float_t         TRTOccupancyBarrelA;
   Float_t         TRTOccupancyBarrelC;
   Float_t         TRTOccupancyEndcapAA;
   Float_t         TRTOccupancyEndcapAC;
   Float_t         TRTOccupancyEndcapBA;
   Float_t         TRTOccupancyEndcapBC;
   Float_t         eventWeight;
   TVector3        *beamSpot;
   Float_t         primaryVertex_sumPt2;
   TVector3        *primaryVertex_position;

   // Truth
   Int_t           truth_status;
   Int_t           truth_pdgId;
   Float_t         truth_d0;
   Float_t         truth_z0;
   Float_t         truth_qOverP;
   TLorentzVector  *truth_p4;
   TVector3        *truth_prodVertex;
   Int_t           truth_parentPdgId;

   // Electron container
   Bool_t          electron_LHLoose;
   Bool_t          electron_LHMedium;
   Bool_t          electron_LHTight;
   Bool_t          electron_Loose;
   Bool_t          electron_Medium;
   Bool_t          electron_Tight;
   Float_t         electron_charge;
   Float_t         electron_ptcone20;
   Float_t         electron_ptcone30;
   Float_t         electron_ptvarcone20;
   Float_t         electron_ptvarcone30;
   TLorentzVector  *electron_p4;

   // Muon container
   UShort_t        muon_author;
   UShort_t        muon_type;
   UChar_t         muon_quality;
   Float_t         muon_charge;
   Float_t         muon_ptcone20;
   Float_t         muon_ptcone30;
   Float_t         muon_ptcone40;
   Float_t         muon_ptvarcone20;
   Float_t         muon_ptvarcone30;
   Float_t         muon_ptvarcone40;
   TLorentzVector  *muon_p4;

   // Tag and probe variables
   Bool_t          InDetTrackParticles_tnp_electron;
   Float_t         InDetTrackParticles_tnp_electron_m;
   Float_t         InDetTrackParticles_tnp_electron_deltaZ0;
   Char_t          InDetTrackParticles_tnp_electron_qxq;
   Bool_t          InDetTrackParticles_tnp_muon;
   Float_t         InDetTrackParticles_tnp_muon_m;
   Float_t         InDetTrackParticles_tnp_muon_deltaZ0;
   Char_t          InDetTrackParticles_tnp_muon_qxq;

   // InDetTrackParticles - for normal ntuples, and tnp muon probes
   UChar_t         InDetTrackParticles_nPixelHits;
   UChar_t         InDetTrackParticles_nPixelHoles;
   UChar_t         InDetTrackParticles_nSCTHits;
   UChar_t         InDetTrackParticles_nSCTHoles;
   UChar_t         InDetTrackParticles_nTRTHits_athena;
   UChar_t         InDetTrackParticles_nTRTHitsXe;
   UChar_t         InDetTrackParticles_nTRTHoles;
   UChar_t         InDetTrackParticles_nTRTOutliers_athena;
   UChar_t         InDetTrackParticles_nTRTHitsHT;
   UChar_t         InDetTrackParticles_nTRTHitsHTXe;
   Float_t         InDetTrackParticles_qOverP;
   Float_t         InDetTrackParticles_d0;
   Float_t         InDetTrackParticles_z0;
   Float_t         InDetTrackParticles_dEdx;
   Float_t         InDetTrackParticles_eProbabilityHT;
   Float_t         InDetTrackParticles_eProbabilityNN;
   Float_t         InDetTrackParticles_trackOccupancy;
   Float_t         InDetTrackParticles_chi2;
   Bool_t          InDetTrackParticles_Loose;
   Bool_t          InDetTrackParticles_LoosePrimary;
   Bool_t          InDetTrackParticles_TightPrimary;
   Float_t         InDetTrackParticles_truthMatchProbability;
   TLorentzVector  *InDetTrackParticles_p4;
   Float_t         InDetTrackParticles_charge;
   Float_t         InDetTrackParticles_d0sig;
   Float_t         InDetTrackParticles_z0sig;
   Float_t         InDetTrackParticles_z0sinTheta;
   UChar_t         InDetTrackParticles_nTRTHits;
   UChar_t         InDetTrackParticles_nTRTOutliers;
   UChar_t         InDetTrackParticles_nTRTHitsPrecision;
   UChar_t         InDetTrackParticles_nTRTHitsTube;
   Float_t         InDetTrackParticles_sumL;

   vector<char>    *InDetTrackParticles_hit_type_athena;
   vector<float>   *InDetTrackParticles_hit_r;
   vector<float>   *InDetTrackParticles_hit_z;
   vector<float>   *InDetTrackParticles_hit_localTheta;
   vector<float>   *InDetTrackParticles_hit_localPhi;
   vector<float>   *InDetTrackParticles_hit_rTrackToWire;
   vector<float>   *InDetTrackParticles_hit_unbiasedResidual;
   vector<float>   *InDetTrackParticles_hit_biasedResidual;
   vector<float>   *InDetTrackParticles_hit_unbiasedPull;
   vector<float>   *InDetTrackParticles_hit_biasedPull;
   vector<float>   *InDetTrackParticles_hit_error;
   vector<char>    *InDetTrackParticles_hit_gasType;
   vector<short>   *InDetTrackParticles_hit_bec;
   vector<char>    *InDetTrackParticles_hit_layer;
   vector<char>    *InDetTrackParticles_hit_strawLayer;
   vector<char>    *InDetTrackParticles_hit_strawNumber;
   vector<char>    *InDetTrackParticles_hit_board;
   vector<unsigned short> *InDetTrackParticles_hit_chip;
   vector<char>    *InDetTrackParticles_hit_modulePhi;
   vector<unsigned int> *InDetTrackParticles_hit_bitPattern;
   vector<float>   *InDetTrackParticles_hit_strawPhi;
   vector<float>   *InDetTrackParticles_hit_t0;
   vector<float>   *InDetTrackParticles_hit_leadingEdge;
   vector<float>   *InDetTrackParticles_hit_driftTime;
   vector<float>   *InDetTrackParticles_hit_driftRadius;
   vector<float>   *InDetTrackParticles_hit_tot;
   vector<char>    *InDetTrackParticles_hit_type;
   vector<bool>    *InDetTrackParticles_hit_isHighThresholdMiddleBit;
   vector<TVector3> *InDetTrackParticles_hit_strawPosition;
   vector<float>   *InDetTrackParticles_hit_l;
   vector<float>   *InDetTrackParticles_hit_driftTimeCorrected;

   // GSF (electrons)
   UChar_t         GSFTrackParticles_nPixelHits;
   UChar_t         GSFTrackParticles_nPixelHoles;
   UChar_t         GSFTrackParticles_nSCTHits;
   UChar_t         GSFTrackParticles_nSCTHoles;
   UChar_t         GSFTrackParticles_nTRTHits_athena;
   UChar_t         GSFTrackParticles_nTRTHitsXe;
   UChar_t         GSFTrackParticles_nTRTHoles;
   UChar_t         GSFTrackParticles_nTRTOutliers_athena;
   UChar_t         GSFTrackParticles_nTRTHitsHT;
   UChar_t         GSFTrackParticles_nTRTHitsHTXe;
   Float_t         GSFTrackParticles_qOverP;
   Float_t         GSFTrackParticles_d0;
   Float_t         GSFTrackParticles_z0;
   Float_t         GSFTrackParticles_dEdx;
   Float_t         GSFTrackParticles_eProbabilityHT;
   Float_t         GSFTrackParticles_eProbabilityNN;
   Float_t         GSFTrackParticles_trackOccupancy;
   Float_t         GSFTrackParticles_chi2;
   Bool_t          GSFTrackParticles_Loose;
   Bool_t          GSFTrackParticles_LoosePrimary;
   Bool_t          GSFTrackParticles_TightPrimary;
   Float_t         GSFTrackParticles_truthMatchProbability;
   TLorentzVector  *GSFTrackParticles_p4;
   Float_t         GSFTrackParticles_charge;
   Float_t         GSFTrackParticles_d0sig;
   Float_t         GSFTrackParticles_z0sig;
   Float_t         GSFTrackParticles_z0sinTheta;
   UChar_t         GSFTrackParticles_nTRTHits;
   UChar_t         GSFTrackParticles_nTRTOutliers;
   UChar_t         GSFTrackParticles_nTRTHitsPrecision;
   UChar_t         GSFTrackParticles_nTRTHitsTube;
   Float_t         GSFTrackParticles_sumL;

   vector<char>    *GSFTrackParticles_hit_type_athena;
   vector<float>   *GSFTrackParticles_hit_r;
   vector<float>   *GSFTrackParticles_hit_z;
   vector<float>   *GSFTrackParticles_hit_localTheta;
   vector<float>   *GSFTrackParticles_hit_localPhi;
   vector<float>   *GSFTrackParticles_hit_rTrackToWire;
   vector<float>   *GSFTrackParticles_hit_unbiasedResidual;
   vector<float>   *GSFTrackParticles_hit_biasedResidual;
   vector<float>   *GSFTrackParticles_hit_unbiasedPull;
   vector<float>   *GSFTrackParticles_hit_biasedPull;
   vector<float>   *GSFTrackParticles_hit_error;
   vector<char>    *GSFTrackParticles_hit_gasType;
   vector<short>   *GSFTrackParticles_hit_bec;
   vector<char>    *GSFTrackParticles_hit_layer;
   vector<char>    *GSFTrackParticles_hit_strawLayer;
   vector<char>    *GSFTrackParticles_hit_strawNumber;
   vector<char>    *GSFTrackParticles_hit_board;
   vector<unsigned short> *GSFTrackParticles_hit_chip;
   vector<char>    *GSFTrackParticles_hit_modulePhi;
   vector<unsigned int> *GSFTrackParticles_hit_bitPattern;
   vector<float>   *GSFTrackParticles_hit_strawPhi;
   vector<float>   *GSFTrackParticles_hit_t0;
   vector<float>   *GSFTrackParticles_hit_leadingEdge;
   vector<float>   *GSFTrackParticles_hit_driftTime;
   vector<float>   *GSFTrackParticles_hit_driftRadius;
   vector<float>   *GSFTrackParticles_hit_tot;
   vector<char>    *GSFTrackParticles_hit_type;
   vector<bool>    *GSFTrackParticles_hit_isHighThresholdMiddleBit;
   vector<TVector3> *GSFTrackParticles_hit_strawPosition;
   vector<float>   *GSFTrackParticles_hit_l;
   vector<float>   *GSFTrackParticles_hit_driftTimeCorrected;

   // electron_gsfTrack - for tnp electron probes
   UChar_t         electron_gsfTrack_nPixelHits;
   UChar_t         electron_gsfTrack_nPixelHoles;
   UChar_t         electron_gsfTrack_nSCTHits;
   UChar_t         electron_gsfTrack_nSCTHoles;
   UChar_t         electron_gsfTrack_nTRTHits_athena;
   UChar_t         electron_gsfTrack_nTRTHitsXe;
   UChar_t         electron_gsfTrack_nTRTHoles;
   UChar_t         electron_gsfTrack_nTRTOutliers_athena;
   UChar_t         electron_gsfTrack_nTRTHitsHT;
   UChar_t         electron_gsfTrack_nTRTHitsHTXe;
   Float_t         electron_gsfTrack_qOverP;
   Float_t         electron_gsfTrack_d0;
   Float_t         electron_gsfTrack_z0;
   Float_t         electron_gsfTrack_dEdx;
   Float_t         electron_gsfTrack_eProbabilityHT;
   Float_t         electron_gsfTrack_eProbabilityNN;
   Float_t         electron_gsfTrack_trackOccupancy;
   Float_t         electron_gsfTrack_chi2;
   TLorentzVector  *electron_gsfTrack_p4;
   Float_t         electron_gsfTrack_charge;
   Float_t         electron_gsfTrack_d0sig;
   Float_t         electron_gsfTrack_z0sig;
   Float_t         electron_gsfTrack_z0sinTheta;
   UChar_t         electron_gsfTrack_nTRTHits;
   UChar_t         electron_gsfTrack_nTRTOutliers;
   UChar_t         electron_gsfTrack_nTRTHitsPrecision;
   UChar_t         electron_gsfTrack_nTRTHitsTube;
   Float_t         electron_gsfTrack_sumL;

   vector<char>    *electron_gsfTrack_hit_type_athena;
   vector<float>   *electron_gsfTrack_hit_r;
   vector<float>   *electron_gsfTrack_hit_z;
   vector<float>   *electron_gsfTrack_hit_localTheta;
   vector<float>   *electron_gsfTrack_hit_localPhi;
   vector<float>   *electron_gsfTrack_hit_rTrackToWire;
   vector<float>   *electron_gsfTrack_hit_unbiasedResidual;
   vector<float>   *electron_gsfTrack_hit_biasedResidual;
   vector<float>   *electron_gsfTrack_hit_unbiasedPull;
   vector<float>   *electron_gsfTrack_hit_biasedPull;
   vector<float>   *electron_gsfTrack_hit_error;
   vector<char>    *electron_gsfTrack_hit_gasType;
   vector<short>   *electron_gsfTrack_hit_bec;
   vector<char>    *electron_gsfTrack_hit_layer;
   vector<char>    *electron_gsfTrack_hit_strawLayer;
   vector<char>    *electron_gsfTrack_hit_strawNumber;
   vector<char>    *electron_gsfTrack_hit_board;
   vector<unsigned short> *electron_gsfTrack_hit_chip;
   vector<char>    *electron_gsfTrack_hit_modulePhi;
   vector<unsigned int> *electron_gsfTrack_hit_bitPattern;
   vector<float>   *electron_gsfTrack_hit_strawPhi;
   vector<float>   *electron_gsfTrack_hit_t0;
   vector<float>   *electron_gsfTrack_hit_leadingEdge;
   vector<float>   *electron_gsfTrack_hit_driftTime;
   vector<float>   *electron_gsfTrack_hit_driftRadius;
   vector<float>   *electron_gsfTrack_hit_tot;
   vector<char>    *electron_gsfTrack_hit_type;
   vector<bool>    *electron_gsfTrack_hit_isHighThresholdMiddleBit;
   vector<TVector3> *electron_gsfTrack_hit_strawPosition;
   vector<float>   *electron_gsfTrack_hit_l;
   vector<float>   *electron_gsfTrack_hit_driftTimeCorrected;

   // List of branches

   // event-level
   TBranch        *b_runNumber;   //!
   TBranch        *b_eventNumber;   //!
   TBranch        *b_averageInteractionsPerCrossing;   //!
   TBranch        *b_TRTOccupancyGlobal;   //!
   TBranch        *b_TRTOccupancyBarrelA;   //!
   TBranch        *b_TRTOccupancyBarrelC;   //!
   TBranch        *b_TRTOccupancyEndcapAA;   //!
   TBranch        *b_TRTOccupancyEndcapAC;   //!
   TBranch        *b_TRTOccupancyEndcapBA;   //!
   TBranch        *b_TRTOccupancyEndcapBC;   //!
   TBranch        *b_eventWeight;   //!
   TBranch        *b_beamSpot;   //!
   TBranch        *b_primaryVertex_sumPt2;   //!
   TBranch        *b_primaryVertex_position;   //!

   // truth
   TBranch        *b_truth_status;   //!
   TBranch        *b_truth_pdgId;   //!
   TBranch        *b_truth_d0;   //!
   TBranch        *b_truth_z0;   //!
   TBranch        *b_truth_qOverP;   //!
   TBranch        *b_truth_p4;   //!
   TBranch        *b_truth_prodVertex;   //!
   TBranch        *b_truth_parentPdgId;   //!

   // electron container
   TBranch        *b_electron_LHLoose;   //!
   TBranch        *b_electron_LHMedium;   //!
   TBranch        *b_electron_LHTight;   //!
   TBranch        *b_electron_Loose;   //!
   TBranch        *b_electron_Medium;   //!
   TBranch        *b_electron_Tight;   //!
   TBranch        *b_electron_charge;   //!
   TBranch        *b_electron_ptcone20;   //!
   TBranch        *b_electron_ptcone30;   //!
   TBranch        *b_electron_ptvarcone20;   //!
   TBranch        *b_electron_ptvarcone30;   //!
   TBranch        *b_electron_p4;   //!

   // Muon container
   TBranch        *b_muon_author;   //!
   TBranch        *b_muon_type;   //!
   TBranch        *b_muon_quality;   //!
   TBranch        *b_muon_charge;   //!
   TBranch        *b_muon_ptcone20;   //!
   TBranch        *b_muon_ptcone30;   //!
   TBranch        *b_muon_ptcone40;   //!
   TBranch        *b_muon_ptvarcone20;   //!
   TBranch        *b_muon_ptvarcone30;   //!
   TBranch        *b_muon_ptvarcone40;   //!
   TBranch        *b_muon_p4;   //!

   // InDetTrackParticles
   TBranch        *b_InDetTrackParticles_nPixelHits;   //!
   TBranch        *b_InDetTrackParticles_nPixelHoles;   //!
   TBranch        *b_InDetTrackParticles_nSCTHits;   //!
   TBranch        *b_InDetTrackParticles_nSCTHoles;   //!
   TBranch        *b_InDetTrackParticles_nTRTHits_athena;   //!
   TBranch        *b_InDetTrackParticles_nTRTHitsXe;   //!
   TBranch        *b_InDetTrackParticles_nTRTHoles;   //!
   TBranch        *b_InDetTrackParticles_nTRTOutliers_athena;   //!
   TBranch        *b_InDetTrackParticles_nTRTHitsHT;   //!
   TBranch        *b_InDetTrackParticles_nTRTHitsHTXe;   //!
   TBranch        *b_InDetTrackParticles_qOverP;   //!
   TBranch        *b_InDetTrackParticles_d0;   //!
   TBranch        *b_InDetTrackParticles_z0;   //!
   TBranch        *b_InDetTrackParticles_dEdx;   //!
   TBranch        *b_InDetTrackParticles_eProbabilityHT;   //!
   TBranch        *b_InDetTrackParticles_eProbabilityNN;   //!
   TBranch        *b_InDetTrackParticles_trackOccupancy;   //!
   TBranch        *b_InDetTrackParticles_chi2;   //!
   TBranch        *b_InDetTrackParticles_Loose;   //!
   TBranch        *b_InDetTrackParticles_LoosePrimary;   //!
   TBranch        *b_InDetTrackParticles_TightPrimary;   //!
   TBranch        *b_InDetTrackParticles_tnp_electron;   //!
   TBranch        *b_InDetTrackParticles_tnp_electron_m;   //!
   TBranch        *b_InDetTrackParticles_tnp_electron_deltaZ0;   //!
   TBranch        *b_InDetTrackParticles_tnp_electron_qxq;   //!
   TBranch        *b_InDetTrackParticles_tnp_muon;   //!
   TBranch        *b_InDetTrackParticles_tnp_muon_m;   //!
   TBranch        *b_InDetTrackParticles_tnp_muon_deltaZ0;   //!
   TBranch        *b_InDetTrackParticles_tnp_muon_qxq;   //!
   TBranch        *b_InDetTrackParticles_truthMatchProbability;   //!
   TBranch        *b_InDetTrackParticles_p4;   //!
   TBranch        *b_InDetTrackParticles_charge;   //!
   TBranch        *b_InDetTrackParticles_d0sig;   //!
   TBranch        *b_InDetTrackParticles_z0sig;   //!
   TBranch        *b_InDetTrackParticles_z0sinTheta;   //!
   TBranch        *b_InDetTrackParticles_nTRTHits;   //!
   TBranch        *b_InDetTrackParticles_nTRTOutliers;   //!
   TBranch        *b_InDetTrackParticles_nTRTHitsPrecision;   //!
   TBranch        *b_InDetTrackParticles_nTRTHitsTube;   //!
   TBranch        *b_InDetTrackParticles_sumL;   //!
   TBranch        *b_InDetTrackParticles_hit_type_athena;   //!
   TBranch        *b_InDetTrackParticles_hit_r;   //!
   TBranch        *b_InDetTrackParticles_hit_z;   //!
   TBranch        *b_InDetTrackParticles_hit_localTheta;   //!
   TBranch        *b_InDetTrackParticles_hit_localPhi;   //!
   TBranch        *b_InDetTrackParticles_hit_rTrackToWire;   //!
   TBranch        *b_InDetTrackParticles_hit_unbiasedResidual;   //!
   TBranch        *b_InDetTrackParticles_hit_biasedResidual;   //!
   TBranch        *b_InDetTrackParticles_hit_unbiasedPull;   //!
   TBranch        *b_InDetTrackParticles_hit_biasedPull;   //!
   TBranch        *b_InDetTrackParticles_hit_error;   //!
   TBranch        *b_InDetTrackParticles_hit_gasType;   //!
   TBranch        *b_InDetTrackParticles_hit_bec;   //!
   TBranch        *b_InDetTrackParticles_hit_layer;   //!
   TBranch        *b_InDetTrackParticles_hit_strawLayer;   //!
   TBranch        *b_InDetTrackParticles_hit_strawNumber;   //!
   TBranch        *b_InDetTrackParticles_hit_board;   //!
   TBranch        *b_InDetTrackParticles_hit_chip;   //!
   TBranch        *b_InDetTrackParticles_hit_modulePhi;   //!
   TBranch        *b_InDetTrackParticles_hit_bitPattern;   //!
   TBranch        *b_InDetTrackParticles_hit_strawPhi;   //!
   TBranch        *b_InDetTrackParticles_hit_t0;   //!
   TBranch        *b_InDetTrackParticles_hit_leadingEdge;   //!
   TBranch        *b_InDetTrackParticles_hit_driftTime;   //!
   TBranch        *b_InDetTrackParticles_hit_driftRadius;   //!
   TBranch        *b_InDetTrackParticles_hit_tot;   //!
   TBranch        *b_InDetTrackParticles_hit_type;   //!
   TBranch        *b_InDetTrackParticles_hit_isHighThresholdMiddleBit;   //!
   TBranch        *b_InDetTrackParticles_hit_strawPosition;   //!
   TBranch        *b_InDetTrackParticles_hit_l;   //!
   TBranch        *b_InDetTrackParticles_hit_driftTimeCorrected;   //!

   // GSFTrackParticles
   TBranch        *b_GSFTrackParticles_nPixelHits;   //!
   TBranch        *b_GSFTrackParticles_nPixelHoles;   //!
   TBranch        *b_GSFTrackParticles_nSCTHits;   //!
   TBranch        *b_GSFTrackParticles_nSCTHoles;   //!
   TBranch        *b_GSFTrackParticles_nTRTHits_athena;   //!
   TBranch        *b_GSFTrackParticles_nTRTHitsXe;   //!
   TBranch        *b_GSFTrackParticles_nTRTHoles;   //!
   TBranch        *b_GSFTrackParticles_nTRTOutliers_athena;   //!
   TBranch        *b_GSFTrackParticles_nTRTHitsHT;   //!
   TBranch        *b_GSFTrackParticles_nTRTHitsHTXe;   //!
   TBranch        *b_GSFTrackParticles_qOverP;   //!
   TBranch        *b_GSFTrackParticles_d0;   //!
   TBranch        *b_GSFTrackParticles_z0;   //!
   TBranch        *b_GSFTrackParticles_dEdx;   //!
   TBranch        *b_GSFTrackParticles_eProbabilityHT;   //!
   TBranch        *b_GSFTrackParticles_eProbabilityNN;   //!
   TBranch        *b_GSFTrackParticles_trackOccupancy;   //!
   TBranch        *b_GSFTrackParticles_chi2;   //!
   TBranch        *b_GSFTrackParticles_Loose;   //!
   TBranch        *b_GSFTrackParticles_LoosePrimary;   //!
   TBranch        *b_GSFTrackParticles_TightPrimary;   //!
   TBranch        *b_GSFTrackParticles_truthMatchProbability;   //!
   TBranch        *b_GSFTrackParticles_p4;   //!
   TBranch        *b_GSFTrackParticles_charge;   //!
   TBranch        *b_GSFTrackParticles_d0sig;   //!
   TBranch        *b_GSFTrackParticles_z0sig;   //!
   TBranch        *b_GSFTrackParticles_z0sinTheta;   //!
   TBranch        *b_GSFTrackParticles_nTRTHits;   //!
   TBranch        *b_GSFTrackParticles_nTRTOutliers;   //!
   TBranch        *b_GSFTrackParticles_nTRTHitsPrecision;   //!
   TBranch        *b_GSFTrackParticles_nTRTHitsTube;   //!
   TBranch        *b_GSFTrackParticles_sumL;   //!
   TBranch        *b_GSFTrackParticles_hit_type_athena;   //!
   TBranch        *b_GSFTrackParticles_hit_r;   //!
   TBranch        *b_GSFTrackParticles_hit_z;   //!
   TBranch        *b_GSFTrackParticles_hit_localTheta;   //!
   TBranch        *b_GSFTrackParticles_hit_localPhi;   //!
   TBranch        *b_GSFTrackParticles_hit_rTrackToWire;   //!
   TBranch        *b_GSFTrackParticles_hit_unbiasedResidual;   //!
   TBranch        *b_GSFTrackParticles_hit_biasedResidual;   //!
   TBranch        *b_GSFTrackParticles_hit_unbiasedPull;   //!
   TBranch        *b_GSFTrackParticles_hit_biasedPull;   //!
   TBranch        *b_GSFTrackParticles_hit_error;   //!
   TBranch        *b_GSFTrackParticles_hit_gasType;   //!
   TBranch        *b_GSFTrackParticles_hit_bec;   //!
   TBranch        *b_GSFTrackParticles_hit_layer;   //!
   TBranch        *b_GSFTrackParticles_hit_strawLayer;   //!
   TBranch        *b_GSFTrackParticles_hit_strawNumber;   //!
   TBranch        *b_GSFTrackParticles_hit_board;   //!
   TBranch        *b_GSFTrackParticles_hit_chip;   //!
   TBranch        *b_GSFTrackParticles_hit_modulePhi;   //!
   TBranch        *b_GSFTrackParticles_hit_bitPattern;   //!
   TBranch        *b_GSFTrackParticles_hit_strawPhi;   //!
   TBranch        *b_GSFTrackParticles_hit_t0;   //!
   TBranch        *b_GSFTrackParticles_hit_leadingEdge;   //!
   TBranch        *b_GSFTrackParticles_hit_driftTime;   //!
   TBranch        *b_GSFTrackParticles_hit_driftRadius;   //!
   TBranch        *b_GSFTrackParticles_hit_tot;   //!
   TBranch        *b_GSFTrackParticles_hit_type;   //!
   TBranch        *b_GSFTrackParticles_hit_isHighThresholdMiddleBit;   //!
   TBranch        *b_GSFTrackParticles_hit_strawPosition;   //!
   TBranch        *b_GSFTrackParticles_hit_l;   //!
   TBranch        *b_GSFTrackParticles_hit_driftTimeCorrected;   //!

   // tnp electrons
   TBranch        *b_electron_gsfTrack_nPixelHits;   //!
   TBranch        *b_electron_gsfTrack_nPixelHoles;   //!
   TBranch        *b_electron_gsfTrack_nSCTHits;   //!
   TBranch        *b_electron_gsfTrack_nSCTHoles;   //!
   TBranch        *b_electron_gsfTrack_nTRTHits_athena;   //!
   TBranch        *b_electron_gsfTrack_nTRTHitsXe;   //!
   TBranch        *b_electron_gsfTrack_nTRTHoles;   //!
   TBranch        *b_electron_gsfTrack_nTRTOutliers_athena;   //!
   TBranch        *b_electron_gsfTrack_nTRTHitsHT;   //!
   TBranch        *b_electron_gsfTrack_nTRTHitsHTXe;   //!
   TBranch        *b_electron_gsfTrack_qOverP;   //!
   TBranch        *b_electron_gsfTrack_d0;   //!
   TBranch        *b_electron_gsfTrack_z0;   //!
   TBranch        *b_electron_gsfTrack_dEdx;   //!
   TBranch        *b_electron_gsfTrack_eProbabilityHT;   //!
   TBranch        *b_electron_gsfTrack_eProbabilityNN;   //!
   TBranch        *b_electron_gsfTrack_trackOccupancy;   //!
   TBranch        *b_electron_gsfTrack_chi2;   //!
   TBranch        *b_electron_gsfTrack_p4;   //!
   TBranch        *b_electron_gsfTrack_charge;   //!
   TBranch        *b_electron_gsfTrack_d0sig;   //!
   TBranch        *b_electron_gsfTrack_z0sig;   //!
   TBranch        *b_electron_gsfTrack_z0sinTheta;   //!
   TBranch        *b_electron_gsfTrack_nTRTHits;   //!
   TBranch        *b_electron_gsfTrack_nTRTOutliers;   //!
   TBranch        *b_electron_gsfTrack_nTRTHitsPrecision;   //!
   TBranch        *b_electron_gsfTrack_nTRTHitsTube;   //!
   TBranch        *b_electron_gsfTrack_sumL;   //!
   TBranch        *b_electron_gsfTrack_hit_type_athena;   //!
   TBranch        *b_electron_gsfTrack_hit_r;   //!
   TBranch        *b_electron_gsfTrack_hit_z;   //!
   TBranch        *b_electron_gsfTrack_hit_localTheta;   //!
   TBranch        *b_electron_gsfTrack_hit_localPhi;   //!
   TBranch        *b_electron_gsfTrack_hit_rTrackToWire;   //!
   TBranch        *b_electron_gsfTrack_hit_unbiasedResidual;   //!
   TBranch        *b_electron_gsfTrack_hit_biasedResidual;   //!
   TBranch        *b_electron_gsfTrack_hit_unbiasedPull;   //!
   TBranch        *b_electron_gsfTrack_hit_biasedPull;   //!
   TBranch        *b_electron_gsfTrack_hit_error;   //!
   TBranch        *b_electron_gsfTrack_hit_gasType;   //!
   TBranch        *b_electron_gsfTrack_hit_bec;   //!
   TBranch        *b_electron_gsfTrack_hit_layer;   //!
   TBranch        *b_electron_gsfTrack_hit_strawLayer;   //!
   TBranch        *b_electron_gsfTrack_hit_strawNumber;   //!
   TBranch        *b_electron_gsfTrack_hit_board;   //!
   TBranch        *b_electron_gsfTrack_hit_chip;   //!
   TBranch        *b_electron_gsfTrack_hit_modulePhi;   //!
   TBranch        *b_electron_gsfTrack_hit_bitPattern;   //!
   TBranch        *b_electron_gsfTrack_hit_strawPhi;   //!
   TBranch        *b_electron_gsfTrack_hit_t0;   //!
   TBranch        *b_electron_gsfTrack_hit_leadingEdge;   //!
   TBranch        *b_electron_gsfTrack_hit_driftTime;   //!
   TBranch        *b_electron_gsfTrack_hit_driftRadius;   //!
   TBranch        *b_electron_gsfTrack_hit_tot;   //!
   TBranch        *b_electron_gsfTrack_hit_type;   //!
   TBranch        *b_electron_gsfTrack_hit_isHighThresholdMiddleBit;   //!
   TBranch        *b_electron_gsfTrack_hit_strawPosition;   //!
   TBranch        *b_electron_gsfTrack_hit_l;   //!
   TBranch        *b_electron_gsfTrack_hit_driftTimeCorrected;   //!

   TRT(TTree *tree=0);
   virtual ~TRT();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop();
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
};

#endif

#ifdef TRT_cxx
TRT::TRT(TTree *tree) : fChain(0) 
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("R22_Run2_MC_ZEE_xTRTNTupleTagAndProbe_18300.root");
      if (!f || !f->IsOpen()) {
         f = new TFile("R22_Run2_MC_ZEE_xTRTNTupleTagAndProbe_18300.root");
      }
      f->GetObject("TRT",tree);

   }
   Init(tree);
}

TRT::~TRT()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t TRT::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t TRT::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->GetTreeNumber() != fCurrent) {
      fCurrent = fChain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void TRT::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set object pointer
   beamSpot = 0;
   primaryVertex_position = 0;

   truth_p4 = 0;
   truth_prodVertex = 0;

   InDetTrackParticles_p4 = 0;
   InDetTrackParticles_hit_type_athena = 0;
   InDetTrackParticles_hit_r = 0;
   InDetTrackParticles_hit_z = 0;
   InDetTrackParticles_hit_localTheta = 0;
   InDetTrackParticles_hit_localPhi = 0;
   InDetTrackParticles_hit_rTrackToWire = 0;
   InDetTrackParticles_hit_unbiasedResidual = 0;
   InDetTrackParticles_hit_biasedResidual = 0;
   InDetTrackParticles_hit_unbiasedPull = 0;
   InDetTrackParticles_hit_biasedPull = 0;
   InDetTrackParticles_hit_error = 0;
   InDetTrackParticles_hit_gasType = 0;
   InDetTrackParticles_hit_bec = 0;
   InDetTrackParticles_hit_layer = 0;
   InDetTrackParticles_hit_strawLayer = 0;
   InDetTrackParticles_hit_strawNumber = 0;
   InDetTrackParticles_hit_board = 0;
   InDetTrackParticles_hit_chip = 0;
   InDetTrackParticles_hit_modulePhi = 0;
   InDetTrackParticles_hit_bitPattern = 0;
   InDetTrackParticles_hit_strawPhi = 0;
   InDetTrackParticles_hit_t0 = 0;
   InDetTrackParticles_hit_leadingEdge = 0;
   InDetTrackParticles_hit_driftTime = 0;
   InDetTrackParticles_hit_driftRadius = 0;
   InDetTrackParticles_hit_tot = 0;
   InDetTrackParticles_hit_type = 0;
   InDetTrackParticles_hit_isHighThresholdMiddleBit = 0;
   InDetTrackParticles_hit_strawPosition = 0;
   InDetTrackParticles_hit_l = 0;
   InDetTrackParticles_hit_driftTimeCorrected = 0;

   GSFTrackParticles_p4 = 0;
   GSFTrackParticles_hit_type_athena = 0;
   GSFTrackParticles_hit_r = 0;
   GSFTrackParticles_hit_z = 0;
   GSFTrackParticles_hit_localTheta = 0;
   GSFTrackParticles_hit_localPhi = 0;
   GSFTrackParticles_hit_rTrackToWire = 0;
   GSFTrackParticles_hit_unbiasedResidual = 0;
   GSFTrackParticles_hit_biasedResidual = 0;
   GSFTrackParticles_hit_unbiasedPull = 0;
   GSFTrackParticles_hit_biasedPull = 0;
   GSFTrackParticles_hit_error = 0;
   GSFTrackParticles_hit_gasType = 0;
   GSFTrackParticles_hit_bec = 0;
   GSFTrackParticles_hit_layer = 0;
   GSFTrackParticles_hit_strawLayer = 0;
   GSFTrackParticles_hit_strawNumber = 0;
   GSFTrackParticles_hit_board = 0;
   GSFTrackParticles_hit_chip = 0;
   GSFTrackParticles_hit_modulePhi = 0;
   GSFTrackParticles_hit_bitPattern = 0;
   GSFTrackParticles_hit_strawPhi = 0;
   GSFTrackParticles_hit_t0 = 0;
   GSFTrackParticles_hit_leadingEdge = 0;
   GSFTrackParticles_hit_driftTime = 0;
   GSFTrackParticles_hit_driftRadius = 0;
   GSFTrackParticles_hit_tot = 0;
   GSFTrackParticles_hit_type = 0;
   GSFTrackParticles_hit_isHighThresholdMiddleBit = 0;
   GSFTrackParticles_hit_strawPosition = 0;
   GSFTrackParticles_hit_l = 0;
   GSFTrackParticles_hit_driftTimeCorrected = 0;

   electron_gsfTrack_p4 = 0;
   electron_gsfTrack_hit_type_athena = 0;
   electron_gsfTrack_hit_r = 0;
   electron_gsfTrack_hit_z = 0;
   electron_gsfTrack_hit_localTheta = 0;
   electron_gsfTrack_hit_localPhi = 0;
   electron_gsfTrack_hit_rTrackToWire = 0;
   electron_gsfTrack_hit_unbiasedResidual = 0;
   electron_gsfTrack_hit_biasedResidual = 0;
   electron_gsfTrack_hit_unbiasedPull = 0;
   electron_gsfTrack_hit_biasedPull = 0;
   electron_gsfTrack_hit_error = 0;
   electron_gsfTrack_hit_gasType = 0;
   electron_gsfTrack_hit_bec = 0;
   electron_gsfTrack_hit_layer = 0;
   electron_gsfTrack_hit_strawLayer = 0;
   electron_gsfTrack_hit_strawNumber = 0;
   electron_gsfTrack_hit_board = 0;
   electron_gsfTrack_hit_chip = 0;
   electron_gsfTrack_hit_modulePhi = 0;
   electron_gsfTrack_hit_bitPattern = 0;
   electron_gsfTrack_hit_strawPhi = 0;
   electron_gsfTrack_hit_t0 = 0;
   electron_gsfTrack_hit_leadingEdge = 0;
   electron_gsfTrack_hit_driftTime = 0;
   electron_gsfTrack_hit_driftRadius = 0;
   electron_gsfTrack_hit_tot = 0;
   electron_gsfTrack_hit_type = 0;
   electron_gsfTrack_hit_isHighThresholdMiddleBit = 0;
   electron_gsfTrack_hit_strawPosition = 0;
   electron_gsfTrack_hit_l = 0;
   electron_gsfTrack_hit_driftTimeCorrected = 0;

   electron_p4 = 0;

   muon_p4 = 0;

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("runNumber", &runNumber, &b_runNumber);
   fChain->SetBranchAddress("eventNumber", &eventNumber, &b_eventNumber);
   fChain->SetBranchAddress("averageInteractionsPerCrossing", &averageInteractionsPerCrossing, &b_averageInteractionsPerCrossing);
   fChain->SetBranchAddress("TRTOccupancyGlobal", &TRTOccupancyGlobal, &b_TRTOccupancyGlobal);
   fChain->SetBranchAddress("TRTOccupancyBarrelA", &TRTOccupancyBarrelA, &b_TRTOccupancyBarrelA);
   fChain->SetBranchAddress("TRTOccupancyBarrelC", &TRTOccupancyBarrelC, &b_TRTOccupancyBarrelC);
   fChain->SetBranchAddress("TRTOccupancyEndcapAA", &TRTOccupancyEndcapAA, &b_TRTOccupancyEndcapAA);
   fChain->SetBranchAddress("TRTOccupancyEndcapAC", &TRTOccupancyEndcapAC, &b_TRTOccupancyEndcapAC);
   fChain->SetBranchAddress("TRTOccupancyEndcapBA", &TRTOccupancyEndcapBA, &b_TRTOccupancyEndcapBA);
   fChain->SetBranchAddress("TRTOccupancyEndcapBC", &TRTOccupancyEndcapBC, &b_TRTOccupancyEndcapBC);
   fChain->SetBranchAddress("eventWeight", &eventWeight, &b_eventWeight);
   fChain->SetBranchAddress("beamSpot", &beamSpot, &b_beamSpot);
   fChain->SetBranchAddress("primaryVertex_sumPt2", &primaryVertex_sumPt2, &b_primaryVertex_sumPt2);
   fChain->SetBranchAddress("primaryVertex_position", &primaryVertex_position, &b_primaryVertex_position);

   if (fChain->GetBranch("truth_status")) {
   fChain->SetBranchAddress("truth_status", &truth_status, &b_truth_status);
   fChain->SetBranchAddress("truth_pdgId", &truth_pdgId, &b_truth_pdgId);
   fChain->SetBranchAddress("truth_d0", &truth_d0, &b_truth_d0);
   fChain->SetBranchAddress("truth_z0", &truth_z0, &b_truth_z0);
   fChain->SetBranchAddress("truth_qOverP", &truth_qOverP, &b_truth_qOverP);
   fChain->SetBranchAddress("truth_p4", &truth_p4, &b_truth_p4);
   fChain->SetBranchAddress("truth_prodVertex", &truth_prodVertex, &b_truth_prodVertex);
   fChain->SetBranchAddress("truth_parentPdgId", &truth_parentPdgId, &b_truth_parentPdgId);
   }

   fChain->SetBranchAddress("InDetTrackParticles_nPixelHits", &InDetTrackParticles_nPixelHits, &b_InDetTrackParticles_nPixelHits);
   fChain->SetBranchAddress("InDetTrackParticles_nPixelHoles", &InDetTrackParticles_nPixelHoles, &b_InDetTrackParticles_nPixelHoles);
   fChain->SetBranchAddress("InDetTrackParticles_nSCTHits", &InDetTrackParticles_nSCTHits, &b_InDetTrackParticles_nSCTHits);
   fChain->SetBranchAddress("InDetTrackParticles_nSCTHoles", &InDetTrackParticles_nSCTHoles, &b_InDetTrackParticles_nSCTHoles);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHits_athena", &InDetTrackParticles_nTRTHits_athena, &b_InDetTrackParticles_nTRTHits_athena);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHitsXe", &InDetTrackParticles_nTRTHitsXe, &b_InDetTrackParticles_nTRTHitsXe);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHoles", &InDetTrackParticles_nTRTHoles, &b_InDetTrackParticles_nTRTHoles);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTOutliers_athena", &InDetTrackParticles_nTRTOutliers_athena, &b_InDetTrackParticles_nTRTOutliers_athena);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHitsHT", &InDetTrackParticles_nTRTHitsHT, &b_InDetTrackParticles_nTRTHitsHT);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHitsHTXe", &InDetTrackParticles_nTRTHitsHTXe, &b_InDetTrackParticles_nTRTHitsHTXe);
   fChain->SetBranchAddress("InDetTrackParticles_qOverP", &InDetTrackParticles_qOverP, &b_InDetTrackParticles_qOverP);
   fChain->SetBranchAddress("InDetTrackParticles_d0", &InDetTrackParticles_d0, &b_InDetTrackParticles_d0);
   fChain->SetBranchAddress("InDetTrackParticles_z0", &InDetTrackParticles_z0, &b_InDetTrackParticles_z0);
   fChain->SetBranchAddress("InDetTrackParticles_dEdx", &InDetTrackParticles_dEdx, &b_InDetTrackParticles_dEdx);
   fChain->SetBranchAddress("InDetTrackParticles_eProbabilityHT", &InDetTrackParticles_eProbabilityHT, &b_InDetTrackParticles_eProbabilityHT);
   fChain->SetBranchAddress("InDetTrackParticles_eProbabilityNN", &InDetTrackParticles_eProbabilityNN, &b_InDetTrackParticles_eProbabilityNN);
   fChain->SetBranchAddress("InDetTrackParticles_trackOccupancy", &InDetTrackParticles_trackOccupancy, &b_InDetTrackParticles_trackOccupancy);
   fChain->SetBranchAddress("InDetTrackParticles_chi2", &InDetTrackParticles_chi2, &b_InDetTrackParticles_chi2);
   if (!fChain->GetBranch("InDetTrackParticles_tnp_electron")) fChain->SetBranchAddress("InDetTrackParticles_Loose", &InDetTrackParticles_Loose, &b_InDetTrackParticles_Loose); // not available in tnp ntuples
   fChain->SetBranchAddress("InDetTrackParticles_LoosePrimary", &InDetTrackParticles_LoosePrimary, &b_InDetTrackParticles_LoosePrimary);
   fChain->SetBranchAddress("InDetTrackParticles_TightPrimary", &InDetTrackParticles_TightPrimary, &b_InDetTrackParticles_TightPrimary);

   if (fChain->GetBranch("InDetTrackParticles_tnp_electron")) {
   fChain->SetBranchAddress("InDetTrackParticles_tnp_electron", &InDetTrackParticles_tnp_electron, &b_InDetTrackParticles_tnp_electron);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_electron_m", &InDetTrackParticles_tnp_electron_m, &b_InDetTrackParticles_tnp_electron_m);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_electron_deltaZ0", &InDetTrackParticles_tnp_electron_deltaZ0, &b_InDetTrackParticles_tnp_electron_deltaZ0);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_electron_qxq", &InDetTrackParticles_tnp_electron_qxq, &b_InDetTrackParticles_tnp_electron_qxq);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_muon", &InDetTrackParticles_tnp_muon, &b_InDetTrackParticles_tnp_muon);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_muon_m", &InDetTrackParticles_tnp_muon_m, &b_InDetTrackParticles_tnp_muon_m);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_muon_deltaZ0", &InDetTrackParticles_tnp_muon_deltaZ0, &b_InDetTrackParticles_tnp_muon_deltaZ0);
   fChain->SetBranchAddress("InDetTrackParticles_tnp_muon_qxq", &InDetTrackParticles_tnp_muon_qxq, &b_InDetTrackParticles_tnp_muon_qxq);
   }

   if (fChain->GetBranch("truth_status"))
     fChain->SetBranchAddress("InDetTrackParticles_truthMatchProbability", &InDetTrackParticles_truthMatchProbability, &b_InDetTrackParticles_truthMatchProbability);
   fChain->SetBranchAddress("InDetTrackParticles_p4", &InDetTrackParticles_p4, &b_InDetTrackParticles_p4);
   fChain->SetBranchAddress("InDetTrackParticles_charge", &InDetTrackParticles_charge, &b_InDetTrackParticles_charge);
   fChain->SetBranchAddress("InDetTrackParticles_d0sig", &InDetTrackParticles_d0sig, &b_InDetTrackParticles_d0sig);
   fChain->SetBranchAddress("InDetTrackParticles_z0sig", &InDetTrackParticles_z0sig, &b_InDetTrackParticles_z0sig);
   fChain->SetBranchAddress("InDetTrackParticles_z0sinTheta", &InDetTrackParticles_z0sinTheta, &b_InDetTrackParticles_z0sinTheta);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHits", &InDetTrackParticles_nTRTHits, &b_InDetTrackParticles_nTRTHits);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTOutliers", &InDetTrackParticles_nTRTOutliers, &b_InDetTrackParticles_nTRTOutliers);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHitsPrecision", &InDetTrackParticles_nTRTHitsPrecision, &b_InDetTrackParticles_nTRTHitsPrecision);
   fChain->SetBranchAddress("InDetTrackParticles_nTRTHitsTube", &InDetTrackParticles_nTRTHitsTube, &b_InDetTrackParticles_nTRTHitsTube);
   fChain->SetBranchAddress("InDetTrackParticles_sumL", &InDetTrackParticles_sumL, &b_InDetTrackParticles_sumL);
   fChain->SetBranchAddress("InDetTrackParticles_hit_type_athena", &InDetTrackParticles_hit_type_athena, &b_InDetTrackParticles_hit_type_athena);
   fChain->SetBranchAddress("InDetTrackParticles_hit_r", &InDetTrackParticles_hit_r, &b_InDetTrackParticles_hit_r);
   fChain->SetBranchAddress("InDetTrackParticles_hit_z", &InDetTrackParticles_hit_z, &b_InDetTrackParticles_hit_z);
   fChain->SetBranchAddress("InDetTrackParticles_hit_localTheta", &InDetTrackParticles_hit_localTheta, &b_InDetTrackParticles_hit_localTheta);
   fChain->SetBranchAddress("InDetTrackParticles_hit_localPhi", &InDetTrackParticles_hit_localPhi, &b_InDetTrackParticles_hit_localPhi);
   fChain->SetBranchAddress("InDetTrackParticles_hit_rTrackToWire", &InDetTrackParticles_hit_rTrackToWire, &b_InDetTrackParticles_hit_rTrackToWire);
   fChain->SetBranchAddress("InDetTrackParticles_hit_unbiasedResidual", &InDetTrackParticles_hit_unbiasedResidual, &b_InDetTrackParticles_hit_unbiasedResidual);
   fChain->SetBranchAddress("InDetTrackParticles_hit_biasedResidual", &InDetTrackParticles_hit_biasedResidual, &b_InDetTrackParticles_hit_biasedResidual);
   fChain->SetBranchAddress("InDetTrackParticles_hit_unbiasedPull", &InDetTrackParticles_hit_unbiasedPull, &b_InDetTrackParticles_hit_unbiasedPull);
   fChain->SetBranchAddress("InDetTrackParticles_hit_biasedPull", &InDetTrackParticles_hit_biasedPull, &b_InDetTrackParticles_hit_biasedPull);
   fChain->SetBranchAddress("InDetTrackParticles_hit_error", &InDetTrackParticles_hit_error, &b_InDetTrackParticles_hit_error);
   fChain->SetBranchAddress("InDetTrackParticles_hit_gasType", &InDetTrackParticles_hit_gasType, &b_InDetTrackParticles_hit_gasType);
   fChain->SetBranchAddress("InDetTrackParticles_hit_bec", &InDetTrackParticles_hit_bec, &b_InDetTrackParticles_hit_bec);
   fChain->SetBranchAddress("InDetTrackParticles_hit_layer", &InDetTrackParticles_hit_layer, &b_InDetTrackParticles_hit_layer);
   fChain->SetBranchAddress("InDetTrackParticles_hit_strawLayer", &InDetTrackParticles_hit_strawLayer, &b_InDetTrackParticles_hit_strawLayer);
   fChain->SetBranchAddress("InDetTrackParticles_hit_strawNumber", &InDetTrackParticles_hit_strawNumber, &b_InDetTrackParticles_hit_strawNumber);
   fChain->SetBranchAddress("InDetTrackParticles_hit_board", &InDetTrackParticles_hit_board, &b_InDetTrackParticles_hit_board);
   fChain->SetBranchAddress("InDetTrackParticles_hit_chip", &InDetTrackParticles_hit_chip, &b_InDetTrackParticles_hit_chip);
   fChain->SetBranchAddress("InDetTrackParticles_hit_modulePhi", &InDetTrackParticles_hit_modulePhi, &b_InDetTrackParticles_hit_modulePhi);
   fChain->SetBranchAddress("InDetTrackParticles_hit_bitPattern", &InDetTrackParticles_hit_bitPattern, &b_InDetTrackParticles_hit_bitPattern);
   fChain->SetBranchAddress("InDetTrackParticles_hit_strawPhi", &InDetTrackParticles_hit_strawPhi, &b_InDetTrackParticles_hit_strawPhi);
   fChain->SetBranchAddress("InDetTrackParticles_hit_t0", &InDetTrackParticles_hit_t0, &b_InDetTrackParticles_hit_t0);
   fChain->SetBranchAddress("InDetTrackParticles_hit_leadingEdge", &InDetTrackParticles_hit_leadingEdge, &b_InDetTrackParticles_hit_leadingEdge);
   fChain->SetBranchAddress("InDetTrackParticles_hit_driftTime", &InDetTrackParticles_hit_driftTime, &b_InDetTrackParticles_hit_driftTime);
   fChain->SetBranchAddress("InDetTrackParticles_hit_driftRadius", &InDetTrackParticles_hit_driftRadius, &b_InDetTrackParticles_hit_driftRadius);
   fChain->SetBranchAddress("InDetTrackParticles_hit_tot", &InDetTrackParticles_hit_tot, &b_InDetTrackParticles_hit_tot);
   fChain->SetBranchAddress("InDetTrackParticles_hit_type", &InDetTrackParticles_hit_type, &b_InDetTrackParticles_hit_type);
   fChain->SetBranchAddress("InDetTrackParticles_hit_isHighThresholdMiddleBit", &InDetTrackParticles_hit_isHighThresholdMiddleBit, &b_InDetTrackParticles_hit_isHighThresholdMiddleBit);
   fChain->SetBranchAddress("InDetTrackParticles_hit_strawPosition", &InDetTrackParticles_hit_strawPosition, &b_InDetTrackParticles_hit_strawPosition);
   fChain->SetBranchAddress("InDetTrackParticles_hit_l", &InDetTrackParticles_hit_l, &b_InDetTrackParticles_hit_l);
   fChain->SetBranchAddress("InDetTrackParticles_hit_driftTimeCorrected", &InDetTrackParticles_hit_driftTimeCorrected, &b_InDetTrackParticles_hit_driftTimeCorrected);

   if (fChain->GetBranch("GSFTrackParticles_nPixelHits")) {
   fChain->SetBranchAddress("GSFTrackParticles_nPixelHits", &GSFTrackParticles_nPixelHits, &b_GSFTrackParticles_nPixelHits);
   fChain->SetBranchAddress("GSFTrackParticles_nPixelHoles", &GSFTrackParticles_nPixelHoles, &b_GSFTrackParticles_nPixelHoles);
   fChain->SetBranchAddress("GSFTrackParticles_nSCTHits", &GSFTrackParticles_nSCTHits, &b_GSFTrackParticles_nSCTHits);
   fChain->SetBranchAddress("GSFTrackParticles_nSCTHoles", &GSFTrackParticles_nSCTHoles, &b_GSFTrackParticles_nSCTHoles);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHits_athena", &GSFTrackParticles_nTRTHits_athena, &b_GSFTrackParticles_nTRTHits_athena);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHitsXe", &GSFTrackParticles_nTRTHitsXe, &b_GSFTrackParticles_nTRTHitsXe);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHoles", &GSFTrackParticles_nTRTHoles, &b_GSFTrackParticles_nTRTHoles);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTOutliers_athena", &GSFTrackParticles_nTRTOutliers_athena, &b_GSFTrackParticles_nTRTOutliers_athena);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHitsHT", &GSFTrackParticles_nTRTHitsHT, &b_GSFTrackParticles_nTRTHitsHT);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHitsHTXe", &GSFTrackParticles_nTRTHitsHTXe, &b_GSFTrackParticles_nTRTHitsHTXe);
   fChain->SetBranchAddress("GSFTrackParticles_qOverP", &GSFTrackParticles_qOverP, &b_GSFTrackParticles_qOverP);
   fChain->SetBranchAddress("GSFTrackParticles_d0", &GSFTrackParticles_d0, &b_GSFTrackParticles_d0);
   fChain->SetBranchAddress("GSFTrackParticles_z0", &GSFTrackParticles_z0, &b_GSFTrackParticles_z0);
   fChain->SetBranchAddress("GSFTrackParticles_dEdx", &GSFTrackParticles_dEdx, &b_GSFTrackParticles_dEdx);
   fChain->SetBranchAddress("GSFTrackParticles_eProbabilityHT", &GSFTrackParticles_eProbabilityHT, &b_GSFTrackParticles_eProbabilityHT);
   fChain->SetBranchAddress("GSFTrackParticles_eProbabilityNN", &GSFTrackParticles_eProbabilityNN, &b_GSFTrackParticles_eProbabilityNN);
   fChain->SetBranchAddress("GSFTrackParticles_trackOccupancy", &GSFTrackParticles_trackOccupancy, &b_GSFTrackParticles_trackOccupancy);
   fChain->SetBranchAddress("GSFTrackParticles_chi2", &GSFTrackParticles_chi2, &b_GSFTrackParticles_chi2);
   fChain->SetBranchAddress("GSFTrackParticles_Loose", &GSFTrackParticles_Loose, &b_GSFTrackParticles_Loose);
   fChain->SetBranchAddress("GSFTrackParticles_LoosePrimary", &GSFTrackParticles_LoosePrimary, &b_GSFTrackParticles_LoosePrimary);
   fChain->SetBranchAddress("GSFTrackParticles_TightPrimary", &GSFTrackParticles_TightPrimary, &b_GSFTrackParticles_TightPrimary);
   if (fChain->GetBranch("truth_status"))
     fChain->SetBranchAddress("GSFTrackParticles_truthMatchProbability", &GSFTrackParticles_truthMatchProbability, &b_GSFTrackParticles_truthMatchProbability);
   fChain->SetBranchAddress("GSFTrackParticles_p4", &GSFTrackParticles_p4, &b_GSFTrackParticles_p4);
   fChain->SetBranchAddress("GSFTrackParticles_charge", &GSFTrackParticles_charge, &b_GSFTrackParticles_charge);
   fChain->SetBranchAddress("GSFTrackParticles_d0sig", &GSFTrackParticles_d0sig, &b_GSFTrackParticles_d0sig);
   fChain->SetBranchAddress("GSFTrackParticles_z0sig", &GSFTrackParticles_z0sig, &b_GSFTrackParticles_z0sig);
   fChain->SetBranchAddress("GSFTrackParticles_z0sinTheta", &GSFTrackParticles_z0sinTheta, &b_GSFTrackParticles_z0sinTheta);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHits", &GSFTrackParticles_nTRTHits, &b_GSFTrackParticles_nTRTHits);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTOutliers", &GSFTrackParticles_nTRTOutliers, &b_GSFTrackParticles_nTRTOutliers);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHitsPrecision", &GSFTrackParticles_nTRTHitsPrecision, &b_GSFTrackParticles_nTRTHitsPrecision);
   fChain->SetBranchAddress("GSFTrackParticles_nTRTHitsTube", &GSFTrackParticles_nTRTHitsTube, &b_GSFTrackParticles_nTRTHitsTube);
   fChain->SetBranchAddress("GSFTrackParticles_sumL", &GSFTrackParticles_sumL, &b_GSFTrackParticles_sumL);
   fChain->SetBranchAddress("GSFTrackParticles_hit_type_athena", &GSFTrackParticles_hit_type_athena, &b_GSFTrackParticles_hit_type_athena);
   fChain->SetBranchAddress("GSFTrackParticles_hit_r", &GSFTrackParticles_hit_r, &b_GSFTrackParticles_hit_r);
   fChain->SetBranchAddress("GSFTrackParticles_hit_z", &GSFTrackParticles_hit_z, &b_GSFTrackParticles_hit_z);
   fChain->SetBranchAddress("GSFTrackParticles_hit_localTheta", &GSFTrackParticles_hit_localTheta, &b_GSFTrackParticles_hit_localTheta);
   fChain->SetBranchAddress("GSFTrackParticles_hit_localPhi", &GSFTrackParticles_hit_localPhi, &b_GSFTrackParticles_hit_localPhi);
   fChain->SetBranchAddress("GSFTrackParticles_hit_rTrackToWire", &GSFTrackParticles_hit_rTrackToWire, &b_GSFTrackParticles_hit_rTrackToWire);
   fChain->SetBranchAddress("GSFTrackParticles_hit_unbiasedResidual", &GSFTrackParticles_hit_unbiasedResidual, &b_GSFTrackParticles_hit_unbiasedResidual);
   fChain->SetBranchAddress("GSFTrackParticles_hit_biasedResidual", &GSFTrackParticles_hit_biasedResidual, &b_GSFTrackParticles_hit_biasedResidual);
   fChain->SetBranchAddress("GSFTrackParticles_hit_unbiasedPull", &GSFTrackParticles_hit_unbiasedPull, &b_GSFTrackParticles_hit_unbiasedPull);
   fChain->SetBranchAddress("GSFTrackParticles_hit_biasedPull", &GSFTrackParticles_hit_biasedPull, &b_GSFTrackParticles_hit_biasedPull);
   fChain->SetBranchAddress("GSFTrackParticles_hit_error", &GSFTrackParticles_hit_error, &b_GSFTrackParticles_hit_error);
   fChain->SetBranchAddress("GSFTrackParticles_hit_gasType", &GSFTrackParticles_hit_gasType, &b_GSFTrackParticles_hit_gasType);
   fChain->SetBranchAddress("GSFTrackParticles_hit_bec", &GSFTrackParticles_hit_bec, &b_GSFTrackParticles_hit_bec);
   fChain->SetBranchAddress("GSFTrackParticles_hit_layer", &GSFTrackParticles_hit_layer, &b_GSFTrackParticles_hit_layer);
   fChain->SetBranchAddress("GSFTrackParticles_hit_strawLayer", &GSFTrackParticles_hit_strawLayer, &b_GSFTrackParticles_hit_strawLayer);
   fChain->SetBranchAddress("GSFTrackParticles_hit_strawNumber", &GSFTrackParticles_hit_strawNumber, &b_GSFTrackParticles_hit_strawNumber);
   fChain->SetBranchAddress("GSFTrackParticles_hit_board", &GSFTrackParticles_hit_board, &b_GSFTrackParticles_hit_board);
   fChain->SetBranchAddress("GSFTrackParticles_hit_chip", &GSFTrackParticles_hit_chip, &b_GSFTrackParticles_hit_chip);
   fChain->SetBranchAddress("GSFTrackParticles_hit_modulePhi", &GSFTrackParticles_hit_modulePhi, &b_GSFTrackParticles_hit_modulePhi);
   fChain->SetBranchAddress("GSFTrackParticles_hit_bitPattern", &GSFTrackParticles_hit_bitPattern, &b_GSFTrackParticles_hit_bitPattern);
   fChain->SetBranchAddress("GSFTrackParticles_hit_strawPhi", &GSFTrackParticles_hit_strawPhi, &b_GSFTrackParticles_hit_strawPhi);
   fChain->SetBranchAddress("GSFTrackParticles_hit_t0", &GSFTrackParticles_hit_t0, &b_GSFTrackParticles_hit_t0);
   fChain->SetBranchAddress("GSFTrackParticles_hit_leadingEdge", &GSFTrackParticles_hit_leadingEdge, &b_GSFTrackParticles_hit_leadingEdge);
   fChain->SetBranchAddress("GSFTrackParticles_hit_driftTime", &GSFTrackParticles_hit_driftTime, &b_GSFTrackParticles_hit_driftTime);
   fChain->SetBranchAddress("GSFTrackParticles_hit_driftRadius", &GSFTrackParticles_hit_driftRadius, &b_GSFTrackParticles_hit_driftRadius);
   fChain->SetBranchAddress("GSFTrackParticles_hit_tot", &GSFTrackParticles_hit_tot, &b_GSFTrackParticles_hit_tot);
   fChain->SetBranchAddress("GSFTrackParticles_hit_type", &GSFTrackParticles_hit_type, &b_GSFTrackParticles_hit_type);
   fChain->SetBranchAddress("GSFTrackParticles_hit_isHighThresholdMiddleBit", &GSFTrackParticles_hit_isHighThresholdMiddleBit, &b_GSFTrackParticles_hit_isHighThresholdMiddleBit);
   fChain->SetBranchAddress("GSFTrackParticles_hit_strawPosition", &GSFTrackParticles_hit_strawPosition, &b_GSFTrackParticles_hit_strawPosition);
   fChain->SetBranchAddress("GSFTrackParticles_hit_l", &GSFTrackParticles_hit_l, &b_GSFTrackParticles_hit_l);
   fChain->SetBranchAddress("GSFTrackParticles_hit_driftTimeCorrected", &GSFTrackParticles_hit_driftTimeCorrected, &b_GSFTrackParticles_hit_driftTimeCorrected);
   fChain->SetBranchAddress("GSFTrackParticles_Loose", &GSFTrackParticles_Loose, &b_GSFTrackParticles_Loose);
   fChain->SetBranchAddress("GSFTrackParticles_LoosePrimary", &GSFTrackParticles_LoosePrimary, &b_GSFTrackParticles_LoosePrimary);
   }

   if (fChain->GetBranch("electron_LHLoose")) {
   fChain->SetBranchAddress("electron_LHLoose", &electron_LHLoose, &b_electron_LHLoose);
   fChain->SetBranchAddress("electron_LHMedium", &electron_LHMedium, &b_electron_LHMedium);
   fChain->SetBranchAddress("electron_LHTight", &electron_LHTight, &b_electron_LHTight);
   fChain->SetBranchAddress("electron_Loose", &electron_Loose, &b_electron_Loose);
   fChain->SetBranchAddress("electron_Medium", &electron_Medium, &b_electron_Medium);
   fChain->SetBranchAddress("electron_Tight", &electron_Tight, &b_electron_Tight);
   fChain->SetBranchAddress("electron_charge", &electron_charge, &b_electron_charge);
   fChain->SetBranchAddress("electron_ptcone20", &electron_ptcone20, &b_electron_ptcone20);
   fChain->SetBranchAddress("electron_ptcone30", &electron_ptcone30, &b_electron_ptcone30);
   fChain->SetBranchAddress("electron_ptvarcone20", &electron_ptvarcone20, &b_electron_ptvarcone20);
   fChain->SetBranchAddress("electron_ptvarcone30", &electron_ptvarcone30, &b_electron_ptvarcone30);
   fChain->SetBranchAddress("electron_p4", &electron_p4, &b_electron_p4);
   }

   if (fChain->GetBranch("electron_gsfTrack_nPixelHits")) {
   fChain->SetBranchAddress("electron_gsfTrack_nPixelHits", &electron_gsfTrack_nPixelHits, &b_electron_gsfTrack_nPixelHits);
   fChain->SetBranchAddress("electron_gsfTrack_nPixelHoles", &electron_gsfTrack_nPixelHoles, &b_electron_gsfTrack_nPixelHoles);
   fChain->SetBranchAddress("electron_gsfTrack_nSCTHits", &electron_gsfTrack_nSCTHits, &b_electron_gsfTrack_nSCTHits);
   fChain->SetBranchAddress("electron_gsfTrack_nSCTHoles", &electron_gsfTrack_nSCTHoles, &b_electron_gsfTrack_nSCTHoles);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHits_athena", &electron_gsfTrack_nTRTHits_athena, &b_electron_gsfTrack_nTRTHits_athena);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHitsXe", &electron_gsfTrack_nTRTHitsXe, &b_electron_gsfTrack_nTRTHitsXe);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHoles", &electron_gsfTrack_nTRTHoles, &b_electron_gsfTrack_nTRTHoles);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTOutliers_athena", &electron_gsfTrack_nTRTOutliers_athena, &b_electron_gsfTrack_nTRTOutliers_athena);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHitsHT", &electron_gsfTrack_nTRTHitsHT, &b_electron_gsfTrack_nTRTHitsHT);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHitsHTXe", &electron_gsfTrack_nTRTHitsHTXe, &b_electron_gsfTrack_nTRTHitsHTXe);
   fChain->SetBranchAddress("electron_gsfTrack_qOverP", &electron_gsfTrack_qOverP, &b_electron_gsfTrack_qOverP);
   fChain->SetBranchAddress("electron_gsfTrack_d0", &electron_gsfTrack_d0, &b_electron_gsfTrack_d0);
   fChain->SetBranchAddress("electron_gsfTrack_z0", &electron_gsfTrack_z0, &b_electron_gsfTrack_z0);
   fChain->SetBranchAddress("electron_gsfTrack_dEdx", &electron_gsfTrack_dEdx, &b_electron_gsfTrack_dEdx);
   fChain->SetBranchAddress("electron_gsfTrack_eProbabilityHT", &electron_gsfTrack_eProbabilityHT, &b_electron_gsfTrack_eProbabilityHT);
   fChain->SetBranchAddress("electron_gsfTrack_eProbabilityNN", &electron_gsfTrack_eProbabilityNN, &b_electron_gsfTrack_eProbabilityNN);
   fChain->SetBranchAddress("electron_gsfTrack_trackOccupancy", &electron_gsfTrack_trackOccupancy, &b_electron_gsfTrack_trackOccupancy);
   fChain->SetBranchAddress("electron_gsfTrack_chi2", &electron_gsfTrack_chi2, &b_electron_gsfTrack_chi2);
   fChain->SetBranchAddress("electron_gsfTrack_p4", &electron_gsfTrack_p4, &b_electron_gsfTrack_p4);
   fChain->SetBranchAddress("electron_gsfTrack_charge", &electron_gsfTrack_charge, &b_electron_gsfTrack_charge);
   fChain->SetBranchAddress("electron_gsfTrack_d0sig", &electron_gsfTrack_d0sig, &b_electron_gsfTrack_d0sig);
   fChain->SetBranchAddress("electron_gsfTrack_z0sig", &electron_gsfTrack_z0sig, &b_electron_gsfTrack_z0sig);
   fChain->SetBranchAddress("electron_gsfTrack_z0sinTheta", &electron_gsfTrack_z0sinTheta, &b_electron_gsfTrack_z0sinTheta);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHits", &electron_gsfTrack_nTRTHits, &b_electron_gsfTrack_nTRTHits);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTOutliers", &electron_gsfTrack_nTRTOutliers, &b_electron_gsfTrack_nTRTOutliers);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHitsPrecision", &electron_gsfTrack_nTRTHitsPrecision, &b_electron_gsfTrack_nTRTHitsPrecision);
   fChain->SetBranchAddress("electron_gsfTrack_nTRTHitsTube", &electron_gsfTrack_nTRTHitsTube, &b_electron_gsfTrack_nTRTHitsTube);
   fChain->SetBranchAddress("electron_gsfTrack_sumL", &electron_gsfTrack_sumL, &b_electron_gsfTrack_sumL);
   fChain->SetBranchAddress("electron_gsfTrack_hit_type_athena", &electron_gsfTrack_hit_type_athena, &b_electron_gsfTrack_hit_type_athena);
   fChain->SetBranchAddress("electron_gsfTrack_hit_r", &electron_gsfTrack_hit_r, &b_electron_gsfTrack_hit_r);
   fChain->SetBranchAddress("electron_gsfTrack_hit_z", &electron_gsfTrack_hit_z, &b_electron_gsfTrack_hit_z);
   fChain->SetBranchAddress("electron_gsfTrack_hit_localTheta", &electron_gsfTrack_hit_localTheta, &b_electron_gsfTrack_hit_localTheta);
   fChain->SetBranchAddress("electron_gsfTrack_hit_localPhi", &electron_gsfTrack_hit_localPhi, &b_electron_gsfTrack_hit_localPhi);
   fChain->SetBranchAddress("electron_gsfTrack_hit_rTrackToWire", &electron_gsfTrack_hit_rTrackToWire, &b_electron_gsfTrack_hit_rTrackToWire);
   fChain->SetBranchAddress("electron_gsfTrack_hit_unbiasedResidual", &electron_gsfTrack_hit_unbiasedResidual, &b_electron_gsfTrack_hit_unbiasedResidual);
   fChain->SetBranchAddress("electron_gsfTrack_hit_biasedResidual", &electron_gsfTrack_hit_biasedResidual, &b_electron_gsfTrack_hit_biasedResidual);
   fChain->SetBranchAddress("electron_gsfTrack_hit_unbiasedPull", &electron_gsfTrack_hit_unbiasedPull, &b_electron_gsfTrack_hit_unbiasedPull);
   fChain->SetBranchAddress("electron_gsfTrack_hit_biasedPull", &electron_gsfTrack_hit_biasedPull, &b_electron_gsfTrack_hit_biasedPull);
   fChain->SetBranchAddress("electron_gsfTrack_hit_error", &electron_gsfTrack_hit_error, &b_electron_gsfTrack_hit_error);
   fChain->SetBranchAddress("electron_gsfTrack_hit_gasType", &electron_gsfTrack_hit_gasType, &b_electron_gsfTrack_hit_gasType);
   fChain->SetBranchAddress("electron_gsfTrack_hit_bec", &electron_gsfTrack_hit_bec, &b_electron_gsfTrack_hit_bec);
   fChain->SetBranchAddress("electron_gsfTrack_hit_layer", &electron_gsfTrack_hit_layer, &b_electron_gsfTrack_hit_layer);
   fChain->SetBranchAddress("electron_gsfTrack_hit_strawLayer", &electron_gsfTrack_hit_strawLayer, &b_electron_gsfTrack_hit_strawLayer);
   fChain->SetBranchAddress("electron_gsfTrack_hit_strawNumber", &electron_gsfTrack_hit_strawNumber, &b_electron_gsfTrack_hit_strawNumber);
   fChain->SetBranchAddress("electron_gsfTrack_hit_board", &electron_gsfTrack_hit_board, &b_electron_gsfTrack_hit_board);
   fChain->SetBranchAddress("electron_gsfTrack_hit_chip", &electron_gsfTrack_hit_chip, &b_electron_gsfTrack_hit_chip);
   fChain->SetBranchAddress("electron_gsfTrack_hit_modulePhi", &electron_gsfTrack_hit_modulePhi, &b_electron_gsfTrack_hit_modulePhi);
   fChain->SetBranchAddress("electron_gsfTrack_hit_bitPattern", &electron_gsfTrack_hit_bitPattern, &b_electron_gsfTrack_hit_bitPattern);
   fChain->SetBranchAddress("electron_gsfTrack_hit_strawPhi", &electron_gsfTrack_hit_strawPhi, &b_electron_gsfTrack_hit_strawPhi);
   fChain->SetBranchAddress("electron_gsfTrack_hit_t0", &electron_gsfTrack_hit_t0, &b_electron_gsfTrack_hit_t0);
   fChain->SetBranchAddress("electron_gsfTrack_hit_leadingEdge", &electron_gsfTrack_hit_leadingEdge, &b_electron_gsfTrack_hit_leadingEdge);
   fChain->SetBranchAddress("electron_gsfTrack_hit_driftTime", &electron_gsfTrack_hit_driftTime, &b_electron_gsfTrack_hit_driftTime);
   fChain->SetBranchAddress("electron_gsfTrack_hit_driftRadius", &electron_gsfTrack_hit_driftRadius, &b_electron_gsfTrack_hit_driftRadius);
   fChain->SetBranchAddress("electron_gsfTrack_hit_tot", &electron_gsfTrack_hit_tot, &b_electron_gsfTrack_hit_tot);
   fChain->SetBranchAddress("electron_gsfTrack_hit_type", &electron_gsfTrack_hit_type, &b_electron_gsfTrack_hit_type);
   fChain->SetBranchAddress("electron_gsfTrack_hit_isHighThresholdMiddleBit", &electron_gsfTrack_hit_isHighThresholdMiddleBit, &b_electron_gsfTrack_hit_isHighThresholdMiddleBit);
   fChain->SetBranchAddress("electron_gsfTrack_hit_strawPosition", &electron_gsfTrack_hit_strawPosition, &b_electron_gsfTrack_hit_strawPosition);
   fChain->SetBranchAddress("electron_gsfTrack_hit_l", &electron_gsfTrack_hit_l, &b_electron_gsfTrack_hit_l);
   fChain->SetBranchAddress("electron_gsfTrack_hit_driftTimeCorrected", &electron_gsfTrack_hit_driftTimeCorrected, &b_electron_gsfTrack_hit_driftTimeCorrected);
   }

   if (fChain->GetBranch("muon_author")) {
   fChain->SetBranchAddress("muon_author", &muon_author, &b_muon_author);
   fChain->SetBranchAddress("muon_type", &muon_type, &b_muon_type);
   fChain->SetBranchAddress("muon_quality", &muon_quality, &b_muon_quality);
   fChain->SetBranchAddress("muon_charge", &muon_charge, &b_muon_charge);
   fChain->SetBranchAddress("muon_ptcone20", &muon_ptcone20, &b_muon_ptcone20);
   fChain->SetBranchAddress("muon_ptcone30", &muon_ptcone30, &b_muon_ptcone30);
   fChain->SetBranchAddress("muon_ptcone40", &muon_ptcone40, &b_muon_ptcone40);
   fChain->SetBranchAddress("muon_ptvarcone20", &muon_ptvarcone20, &b_muon_ptvarcone20);
   fChain->SetBranchAddress("muon_ptvarcone30", &muon_ptvarcone30, &b_muon_ptvarcone30);
   fChain->SetBranchAddress("muon_ptvarcone40", &muon_ptvarcone40, &b_muon_ptvarcone40);
   fChain->SetBranchAddress("muon_p4", &muon_p4, &b_muon_p4);
   }
   Notify();
}

Bool_t TRT::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void TRT::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t TRT::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return entry;
}
#endif // #ifdef TRT_cxx
