  //
  // handle the command-line arguments and print out some information before we start to loop.
  //
  cout << endl;

  if (argc==2 || argc>3 ) {
    cout << "\n" << CYellow << "  Usage: " << CNone << argv[0] << " ['sample 0 required tracks' 'sample 1 required tracks'] " << endl << endl;
    return 1;
  }

  Long64_t n_requested_tracks[2] = {-1,-1};
  if (argc==3) {
    n_requested_tracks[0] = atoi(argv[1]);
    n_requested_tracks[1] = atoi(argv[2]);
    if (n_requested_tracks[0]<0) n_requested_tracks[0]=0;
    if (n_requested_tracks[1]<0) n_requested_tracks[1]=0;
    if (n_requested_tracks[0]>=0 && n_requested_tracks[0]<n_available_tracks[0]) n_tracks_to_loop_over[0]=n_requested_tracks[0];
    if (n_requested_tracks[1]>=0 && n_requested_tracks[1]<n_available_tracks[1]) n_tracks_to_loop_over[1]=n_requested_tracks[1];
  }

  cout << CYellow << " INFO: " << CNone << "Input ntuple samples 0: " << CBlue << input_sample_files[0] << CNone << endl;
  cout << CYellow << " INFO: " << CNone << "Input ntuple samples 1: " << CBlue << input_sample_files[1] << CNone << endl;

  if (n_requested_tracks[0]>=0)
    cout << CYellow << " INFO: " << CNone << "Number of request tracks for sample 0: " << CBlue << n_requested_tracks[0] << CNone << endl;
  if (n_requested_tracks[1]>=0)
    cout << CYellow << " INFO: " << CNone << "Number of request tracks for sample 1: " << CBlue << n_requested_tracks[1] << CNone << endl;

  cout << CYellow << " INFO: " << CNone << "Number of available tracks for sample 0: " << CBlue << n_available_tracks[0] << CNone << endl;
  cout << CYellow << " INFO: " << CNone << "Number of available tracks for sample 1: " << CBlue << n_available_tracks[1] << CNone << endl;

  int percent[2];
  percent[0] = 100*n_tracks_to_loop_over[0]/n_available_tracks[0];
  percent[1] = 100*n_tracks_to_loop_over[1]/n_available_tracks[1];
  cout << CYellow << " INFO: " << CNone << "We will loop over " << CBlue << n_tracks_to_loop_over[0]
                               << CNone << " sample 0 tracks (" << CBlue << percent[0] << "% of the total sample" << CNone << ")." << endl;
  cout << CYellow << " INFO: " << CNone << "We will loop over " << CBlue << n_tracks_to_loop_over[1]
                               << CNone << " sample 1 tracks (" << CBlue << percent[1] << "% of the total sample" << CNone << ")." << endl;
